class String
  def entropy
    arr = self.split(//)
    probHash = arr.probability
    h = -1.to_f * probHash.keys.inject(0.to_f) do |sum, i|
      sum + (probHash[i] * (Math.log(probHash[i])/Math.log(2.to_f)))
    end
    h
  end  
end

class Array
    def probability
    probs, size = Hash.new(0.0), 0.0
    each do |e|
      probs[e] += 1.0
      size += 1.0
    end
    probs.keys.each { |e| probs[e] /= size }
    probs
  end
end

module RubyNet
  class RubyClass
    attr_accessor :var1, :var2

    def initialize(var1, var2)
      @var1, @var2 = var1,var2
    end
    
  end
end

# Let's test it in ruby
obj = RubyNet::RubyClass.new(1,2)

p "aa".entropy      # 0 bits
p "ab".entropy      # 1 bit
p "abcd".entropy   # 2 bits

